unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqlite3conn, sqldb, db, FileUtil,
  Forms, Controls, Graphics, Dialogs, DBGrids, PairSplitter,
  DbCtrls, Menus, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Datasource: TDatasource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    Connection: TSQLite3Connection;
    Query: TSQLQuery;
    Querybirthday: TDateField;
    Queryid: TLongintField;
    Queryprename: TStringField;
    Querysurname: TStringField;
    Transaction: TSQLTransaction;
    procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject;
      var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure QueryAfterOpen(DataSet: TDataSet);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  try
    Connection.DatabaseName := GetCurrentDir + PathDelim + 'test.sql';
    Connection.HostName := 'localhost';
    Connection.Connected:=True;

    Query.SQL.Text:=
      'CREATE TABLE IF NOT EXISTS persons (' +
      'id INTEGER PRIMARY KEY AUTOINCREMENT, ' +
      'surname VARCHAR(100), ' +
      'prename VARCHAR(100), ' +
      'birthday DATE);';
    Query.ExecSQL;
    Transaction.Commit;

    Query.SQL.Text := 'SELECT * FROM persons;';
    Query.PacketRecords := 100;
    Query.Open;
  except
  end;
end;

procedure TForm1.QueryAfterOpen(DataSet: TDataSet);
var
  i: Int32;
begin
  for i := 0 to Query.FieldCount - 1 do
    case Query.Fields[i].FieldName of
      'id':
        begin
          DBGrid1.Columns.Items[i].SizePriority := 0;
          DBGrid1.Columns.Items[i].Width := 0;
          DBGrid1.Columns.Items[i].Title.Caption := 'ID';
        end;
      'surname':
        begin
          DBGrid1.Columns.Items[i].SizePriority := 1;
          DBGrid1.Columns.Items[i].Width := 100;
          DBGrid1.Columns.Items[i].Title.Caption := 'Nachname';
        end;
      'prename':
        begin
          DBGrid1.Columns.Items[i].SizePriority := 1;
          DBGrid1.Columns.Items[i].Width := 100;
          DBGrid1.Columns.Items[i].Title.Caption := 'Vorname';
        end;
      'birthday':
        begin
          DBGrid1.Columns.Items[i].SizePriority := 1;
          DBGrid1.Columns.Items[i].Width := 100;
          DBGrid1.Columns.Items[i].Title.Caption := 'Geburtsdatum';
        end;
      else
        begin
          DBGrid1.Columns.Items[i].SizePriority := 1;
          DBGrid1.Columns.Items[i].Width := 100;
          DBGrid1.Columns.Items[i].Title.Caption := Query.Fields[i].FieldName;
        end;
    end;
end;

procedure TForm1.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
begin
  Query.ApplyUpdates;
  Transaction.Commit;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  s: String;
  LField: TStringField;
begin
  s := InputBox('Neue Spalte anlegen', 'Name neue Spalte', '');
  if not s.IsEmpty then
  begin
    DBGrid1.DataSource := nil;
    Query.Close;
    Query.SQL.Text := 'ALTER TABLE persons ADD ' + s + ' VARCHAR(15)';
    Query.ExecSQL;
    Query.SQL.Text := 'SELECT * FROM persons;';
    Query.Open;
    If Assigned(Query.FindField(s)) Then
      Query.FindField(s).Visible := True
    Else Begin
      LField := TStringField.Create(Self);
      LField.FieldName := s;
      LField.DisplayLabel := s;
      Query.Fields.Add(LField);
    End;
    DBGrid1.DataSource := Datasource;
    QueryAfterOpen(nil);
  end;
end;

Procedure TForm1.Button2Click(Sender: TObject);
var
  s: String;
  LField: TStringField;
begin
  s := InputBox('Neue Spalte anzeigen', 'Name vorhandene Spalte', '');
  if not s.IsEmpty then
  begin
    DBGrid1.DataSource := nil;
    If Assigned(Query.FindField(s)) Then
      Query.FindField(s).Visible := True
    Else Begin
      LField := TStringField.Create(Self);
      LField.FieldName := s;
      LField.DisplayLabel := s;
      Query.Fields.Add(LField);
    End;
    DBGrid1.DataSource := Datasource;
    QueryAfterOpen(nil);
  end;
end;

end.

